
const BOW = document.getElementById("bow")
const TARGETS = document.getElementsByClassName("target")

const DELTA = 10
const GRAVITY = .666
const DRAG = .995

var holding = false
var bx = by = 0
var power = 0
var arrow = null
var arrows = []


function run() {
	for (let arrow of arrows)
		arrow.update()
	setTimeout(run, DELTA)
}
run()

class Arrow {

	constructor(x, y, speed, direction) {

		this.x = x
		this.y = y
		this.speed = -speed/6.66
		this.direction = direction + Math.PI/2 // +90deg, i dont understand why, please leave me alone
		this.angle = direction
		this.locked = false

		console.log(direction)

		this.grav = 0
		this.element = document.createElement("div")
		this.element.className = "arrow"
		document.body.appendChild(this.element)
		this.update()

	}

	hitCheck() {

		if (this.x > document.body.offsetWidth  ||
			this.y > document.body.offsetHeight ||
			this.x < 0 || this.y < 0) this.locked = true

		for (let target of TARGETS) {
			let bounds = target.getBoundingClientRect()
			if (this.x < bounds.right && this.x > bounds.left &&
				this.y < bounds.bottom && this.y > bounds.top) {
				this.locked = true
				target.onclick()
			}
		}

	}

	update() {

		if (this.locked) return

		let ox = this.speed * Math.cos(this.direction)
		let oy = this.speed * Math.sin(this.direction) + this.grav
		this.x += ox
		this.y += oy
		this.speed *= DRAG
		this.angle = Math.atan2(ox, oy)*-1 - Math.PI
		this.grav += GRAVITY

		this.hitCheck()

		this.element.style.top  = this.y + "px"
		this.element.style.left = this.x + "px"
		this.element.style.transform = `translate(-50%, -50%) rotate(${this.angle}rad)`

	}

}

window.onmousemove = window.onmouseup = function(e) {

	if (e.buttons % 2 != 1 && !holding)
		return

	const x = e.clientX
	const y = e.clientY

	if (holding) {

		const dx = x - bx
		const dy = y - by
		const radians = Math.atan2(dx, dy) * -1 // i don't...
		power = Math.sqrt(Math.pow(dx, 2) + Math.pow(dy, 2))

		if (e.buttons % 2 != 1) { // Throw arrow
			holding = false
			BOW.style.opacity = 0;
			arrows.push(new Arrow(x, y, power, radians))
			arrow.remove()
		} else {
			arrow.style.transform = `translate(-50%, -50%) rotate(${radians}rad)`
			arrow.style.top  = y + "px"
			arrow.style.left = x + "px"
			BOW.style.transform = `translate(-50%, -50%) rotate(${radians}rad)`
		}

	} else {

		bx = x
		by = y
		holding = true
		arrow = document.createElement("div")
		arrow.className = "arrow"
		document.body.appendChild(arrow)
		BOW.style.opacity = 1;
		BOW.style.top  = arrow.style.top  = by + "px"
		BOW.style.left = arrow.style.left = bx + "px"

	}

}

let orphans = document.querySelectorAll("a:not([onclick])")
for (let orphan of orphans) {
	orphan.onclick = function() {
		window.location = this.href
	}
}
